<?php

class ConnexionController extends Controller { // classe de contrôleur pour la connexion au site
	public function displayValid() { // la fonction d'affichage de réussite
		$this->view->display(); // on affiche la page avec le message de réussites
	}
	
	public function displayDisconnect() { // la fonction d'affichage de réussite
		session_start();
		unset($_SESSION['connected']);
		unset($_SESSION['user']);
		$this->view->display(); // on affiche la page avec le message de réussites
	}
	
	public function displayForm() { // la fonction d'affichage de formulaire
		session_start();
		
		if(isset($_SESSION['connexionErrCode'])) { // si message d'erreur
			$errCode = $_SESSION['connexionErrCode'];
			$errMsg = ($errCode == 0) ? '<h3>Identifiant inconnu !</h3>' : '<h3>Mauvais mot de passe !</h3>'; // on détermine le message à afficher
			unset($_SESSION['connexionErrCode']); // on retire la variable de session
            $this->view->errMsg = $errMsg;
		}
		$this->view->display();
	}
	
	public function verify() { // vérifie que les identifiants sont valides par rapport à la BDD et réalise la connexion
		// méthode avec un stockage de mdp hashé selon la fonction password_hash()
		if(!isset($_POST['login']) || !isset($_POST['password'])) { // si l'une des données manque, erreur
			//appeler une fonction d'erreur
			echo "<h1>Erreur : variables absentes</h1>";
			die();
		}
		
		$pseudo = $_POST['login'];
		$userpassword = $_POST['password']; //le mot de passe utilisateur
		$bddpassword = Connexion::getPassword($pseudo); // le hash du mot de passe stocké en BDD
		
		if($bddpassword == null) { // l'utilisateur n'existe pas => code d'erreur 0
			session_start(); // on démarre une session pour avoir accès aux variables superglobales de session
			$_SESSION["connexionErrCode"] = 0; // on stocke le code d'erreur 
			header('Location:../connexion'); // on redirige vers la page de formulaire (il faut faire un retour dans le dossier parent pour que ça fonctionne, ne me demandez pas pourquoi !)
		}
		else { // l'utilisateur existe
			if(password_verify($userpassword, $bddpassword)) { // la connexion a réussi
				session_start(); // on démarre la session pour pouvoir définir les variables adéquates
				$_SESSION['connected'] = true;
				$_SESSION['user'] = Connexion::getUser(self::slugify($pseudo));
				header('Location:valid'); // on redirige vers la  page OK
			}
			else { // sinon, c'est que le mot de passe est faux
				session_start(); // on démarre une session pour avoir accès aux variables superglobales de session
				$_SESSION["connexionErrCode"] = 2; // on stocke le code d'erreur 
				header('Location:../connexion'); // on redirige vers la page de formulaire (il faut faire un retour dans le dossier parent pour que ça fonctionne, ne me demandez pas pourquoi !)
			}
		}
		
	}
	
}
